package de.uni_passau.fim.seibt.gitwrapper.process;

import java.io.File;
import java.util.LinkedList;
import java.util.List;
import java.util.Optional;

import de.uni_passau.fim.seibt.gitwrapper.process.ProcessExecutor.ExecRes;

public abstract class ToolWrapper {

    protected String cmd;

    public ToolWrapper(String cmd) throws ToolNotWorkingException {
        this.cmd = cmd;

        if (!isWorking()) {
            throw new ToolNotWorkingException(cmd + " is not working.");
        }
    }

    protected abstract boolean isWorking();

    protected Optional<ExecRes> exec(File workingDir, boolean redirectError, List<String> parameters) {
        LinkedList<String> pars = new LinkedList<>(parameters);
        pars.addFirst(cmd);

        return ProcessExecutor.exec(workingDir, redirectError, pars);
    }
}
